//
// Copyright (c) Microsoft. All rights reserved.
// Licensed under the MIT license. See LICENSE file in the project root for full license information. 
//

/*============================================================
**
** Source: test.c
**
** Purpose: Test for wsprintfW() function
**
**
**=========================================================*/
#define UNICODE
#include <palsuite.h>


char * ErrorMessage = NULL; 
WCHAR * BadResult = NULL; 
WCHAR buf[256];

/* memcmp is used to verify the results, so this test is dependent on it. */
/* ditto with strlen */


BOOL test1()
{

   wsprintf(buf, convert("foo %s"), convert("bar"));
   if (memcmp(buf, convert("foo bar"), wcslen(buf)*2+2) != 0)
   {
       ErrorMessage = "ERROR: (Test 1) Failed. The correct string is 'foo bar'"
                      " and the result returned was ";
       BadResult = buf;
       return FAIL;
   }

   wsprintf(buf, convert("foo %ls"), convert("bar"));
   if (memcmp(buf, convert("foo bar"), wcslen(buf)*2 + 2) != 0){
       ErrorMessage = "ERROR: (Test 2) Failed. The correct string is 'foo bar'"
                      " and the result returned was ";
       BadResult = buf;
       return FAIL;
   }

   wsprintf(buf, convert("foo %5s"), convert("bar"));
   if (memcmp(buf, convert("foo   bar"), wcslen(buf)*2 + 2) != 0)
   {
       ErrorMessage = "ERROR: (Test 3) Failed. The correct string is"
                      " 'foo   bar' and the result returned was ";
       BadResult = buf;
       return FAIL;
   }
   wsprintf(buf, convert("foo %.2s"), convert("bar"));
   if (memcmp(buf, convert("foo ba"), wcslen(buf)*2 + 2) != 0)
   {
       ErrorMessage = "ERROR: (Test 4) Failed. The correct string is 'foo ba'"
                      " and the result returned was ";
       BadResult = buf;
       return FAIL;
   }
   wsprintf(buf, convert("foo %5.2s"), convert("bar"));
   if (memcmp(buf, convert("foo    ba"), wcslen(buf)*2 + 2) != 0)
   {
       ErrorMessage = "ERROR: (Test 5) Failed. The correct string is"
                      " 'foo    ba' and the result returned was ";
       BadResult = buf;
       return FAIL;
   }
   wsprintf(buf, convert("foo %-5s"), convert("bar"));
   if (memcmp(buf, convert("foo bar  "), wcslen(buf)*2 + 2) != 0)
   {
       ErrorMessage = "ERROR: (Test 6) Failed. The correct string is"
                      " 'foo bar  ' and the result returned was ";
       BadResult = buf;
       return FAIL;
   }
   wsprintf(buf, convert("foo %05s"), convert("bar"));
   if (memcmp(buf, convert("foo 00bar"), wcslen(buf)*2 + 2) != 0)
   {
       ErrorMessage = "ERROR: (Test 7) Failed. The correct string is"
                      " 'foo 00bar' and the result returned was ";
       BadResult = buf;
       return FAIL;
   }

   return PASS;
}

int __cdecl main(int argc, char *argv[])
{
   /*
    * Initialize the PAL and return FAILURE if this fails
    */

   if(0 != (PAL_Initialize(argc, argv)))
   {
       return FAIL;
   }

   if(test1())
   {
       Fail("%s '%s'\n",ErrorMessage,convertC(BadResult));
   }

   PAL_Terminate();
   return PASS;

}
