using System;
/// <summary>
/// Convert.ToUInt16(Double)
/// </summary>
public class ConvertToUInt165
{
    public static int Main()
    {
        ConvertToUInt165 convertToUInt165 = new ConvertToUInt165();

        TestLibrary.TestFramework.BeginTestCase("ConvertToUInt165");
        if (convertToUInt165.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
    public bool RunTests()
    {
        bool retVal = true;
        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;
        retVal = PosTest2() && retVal;
        retVal = PosTest3() && retVal;
        TestLibrary.TestFramework.LogInformation("[Negative]");
        retVal = NegTest1() && retVal;
        retVal = NegTest2() && retVal;
        return retVal;
    }
    #region PostiveTest
    public bool PosTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest1: Convert to UInt16 from double 1");
        try
        {
            double doubleVal = (double)(UInt16.MaxValue);
            ushort ushortVal = Convert.ToUInt16(doubleVal);
            if (ushortVal != UInt16.MaxValue)
            {
                TestLibrary.TestFramework.LogError("001", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    public bool PosTest2()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest2: Convert to UInt16 from double 2");
        try
        {
            double doubleVal = (double)(UInt16.MinValue);
            ushort ushortVal = Convert.ToUInt16(doubleVal);
            if (ushortVal != UInt16.MinValue)
            {
                TestLibrary.TestFramework.LogError("003", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("004", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    public bool PosTest3()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest3: Convert to UInt16 from double 3");
        try
        {
            double doubleVal = (double)(this.GetInt32(0, (int)(UInt16.MaxValue)));
            ushort ushortVal = Convert.ToUInt16(doubleVal);
            if (ushortVal != (ushort)(doubleVal))
            {
                TestLibrary.TestFramework.LogError("005", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("006", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    #endregion
    #region NegativeTest
    public bool NegTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("NegTest1: the double is larger than UInt16 maxValue");
        try
        {
            double doubleVal = (double)(this.GetInt32((int)(UInt16.MaxValue) + 1, Int32.MaxValue));
            ushort ushortVal = Convert.ToUInt16(doubleVal);
            TestLibrary.TestFramework.LogError("N001", "the double is larger than UInt16 maxValue but not throw exception");
            retVal = false;
        }
        catch (OverflowException) { }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("N002", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    public bool NegTest2()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("NegTest2: the double is less than UInt16 minValue");
        try
        {
            double doubleVal = (double)(this.GetInt32(1, Int32.MaxValue) * (-1));
            ushort ushortVal = Convert.ToUInt16(doubleVal);
            TestLibrary.TestFramework.LogError("N003", "the double is larger than UInt16 maxValue but not throw exception");
            retVal = false;
        }
        catch (OverflowException) { }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("N004", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
        #endregion
    #region HelpMethod
    private Int32 GetInt32(Int32 minValue, Int32 maxValue)
    {
        try
        {
            if (minValue == maxValue)
            {
                return minValue;
            }
            if (minValue < maxValue)
            {
                return minValue + TestLibrary.Generator.GetInt32(-55) % (maxValue - minValue);
            }
        }
        catch
        {
            throw;
        }

        return minValue;
    }
    #endregion
}
