using System;
/// <summary>
/// Convert.ToUInt64(Int64)
/// </summary>
public class ConvertToUInt6411
{
    public static int Main()
    {
        ConvertToUInt6411 convertToUInt6411 = new ConvertToUInt6411();
        TestLibrary.TestFramework.BeginTestCase("ConvertToUInt6411");
        if (convertToUInt6411.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
    public bool RunTests()
    {
        bool retVal = true;
        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;
        retVal = PosTest2() && retVal;
        TestLibrary.TestFramework.LogInformation("[Negative]");
        retVal = NegTest1() && retVal;
        return retVal;
    }
    #region PositiveTest
    public bool PosTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest1: Convert to UInt64 from int64 1");
        try
        {
            Int64 Int64Val = Int64.MaxValue;
            ulong ulongVal = Convert.ToUInt64(Int64Val);
            if (ulongVal != (ulong)Int64Val)
            {
                TestLibrary.TestFramework.LogError("001", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    public bool PosTest2()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest2: Convert to UInt64 from int64 2");
        try
        {
            Int64 Int64Val = TestLibrary.Generator.GetInt64(-55);
            ulong ulongVal = Convert.ToUInt64(Int64Val);
            if (ulongVal != (ulong)Int64Val)
            {
                TestLibrary.TestFramework.LogError("003", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("004", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    #endregion
    #region NegativeTest
    public bool NegTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("NegTest1: the int64 is less than UInt64 minValue");
        try
        {
            Int64 Int64Val = (Int64)this.GetInt32(1, Int32.MaxValue) * (-1);
            ulong ulongVal = Convert.ToUInt64(Int64Val);
            TestLibrary.TestFramework.LogError("N001", "the int32 is less than UInt64 minValue but not throw exception");
            retVal = false;
        }
        catch (OverflowException) { }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("N002", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    #endregion
    #region HelpMethod
    private Int32 GetInt32(Int32 minValue, Int32 maxValue)
    {
        try
        {
            if (minValue == maxValue)
            {
                return minValue;
            }
            if (minValue < maxValue)
            {
                return minValue + TestLibrary.Generator.GetInt32(-55) % (maxValue - minValue);
            }
        }
        catch
        {
            throw;
        }

        return minValue;
    }
    #endregion
}
