using System;
using System.Reflection;

/// <summary>
/// ConstructorName
/// </summary>
public class ConstructorInfoConstructorName
{
    #region Public Methods
    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;
        
        return retVal;
    }

    #region Positive Test Cases
    public bool PosTest1()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("PosTest1: Ensure ConstructorInfo.ContructorName is correct");

        try
        {
            if (ConstructorInfo.ConstructorName != ".ctor")
            {
                TestLibrary.TestFramework.LogError("001.1", "ConstructorName is not correct");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("001.2", "Unexpected exception: " + e);
            TestLibrary.TestFramework.LogInformation(e.StackTrace);
            retVal = false;
        }

        return retVal;
    }
    #endregion
    #endregion

    public static int Main()
    {
        ConstructorInfoConstructorName test = new ConstructorInfoConstructorName();

        TestLibrary.TestFramework.BeginTestCase("ConstructorInfoConstructorName");

        if (test.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
}
