using System;
using System.Reflection.Emit;

/// <summary>
/// Pushr8 [v-yishi]
/// </summary>
public class StackBehaviourPushr8
{
    #region Public Methods
    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;

        return retVal;
    }

    #region Positive Test Cases
    public bool PosTest1()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("PosTest1: Verify the value of Pushr8 is 24");

        try
        {
            int expected = 24;
            int actual = (int)StackBehaviour.Pushr8;

            if (expected != actual)
            {
                TestLibrary.TestFramework.LogError("001.1", "Pushr8's value is not 24");
                TestLibrary.TestFramework.LogInformation("WARNING [LOCAL VARIABLES] expected = " + expected + ", actual = " + actual);
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("001", "Unexpected exception: " + e);
            TestLibrary.TestFramework.LogInformation(e.StackTrace);
            retVal = false;
        }

        return retVal;
    }
    #endregion
    #endregion

    public static int Main()
    {
        StackBehaviourPushr8 test = new StackBehaviourPushr8();

        TestLibrary.TestFramework.BeginTestCase("StackBehaviourPushr8");

        if (test.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 24;
        }
    }
}
